import java.awt.*; 
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JOptionPane;
import javax.swing.border.*;
import javax.swing.*; 

public class versuch1 extends JFrame implements ActionListener
{

	//Hauptelement des Fensters
	Container c; 
	
	//Panels
	JPanel panName;
	JPanel panList;
	JPanel panMenu;
	
	//Buttons
	JButton loadButton; 
	JButton addButton; 
	JButton delButton; 
	
	//Textfeld
	JTextField name;
	JList nameList;
	
	//Labels
	JLabel labelName;
	JLabel labelList;
	
	prList listData;
	
	public versuch1() 
	{ 
		c=getContentPane(); 
		Border empty = new EmptyBorder(0, 10, 0, 10);
		//Eingabepanel
		panName = new JPanel(new BorderLayout());
		panName.setBorder(empty);
		
		//--Eingabepanel: Elemente
		name = new JTextField(); 
		labelName = new JLabel("Eingabefeld:");
		
		//--Eingabepanel: Anordnung
		panName.add(name,BorderLayout.SOUTH);
		panName.add(labelName,BorderLayout.NORTH);
		 
		
		
		//Listpanel
		listData = new prList();
		panList = new JPanel(new BorderLayout());
		panList.setBorder(empty);
		
		//--Listpanel: Elemente
		nameList = new JList(listData);
		nameList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		labelList = new JLabel("Liste:");
		
		//--Listpanel: Anordnung
		panList.add(nameList,BorderLayout.CENTER);
		panList.add(labelList,BorderLayout.NORTH);
		
		
		
		//Menupanel
		panMenu = new JPanel();
		
		//--Menupanel: Elemente
		loadButton = new JButton("Laden");
		loadButton.addActionListener(this);
	
		addButton = new JButton("Hinzufgen");
		addButton.addActionListener(this);
		name.addCaretListener(new TextFieldList(addButton,name));
		addButton.setEnabled(false);
		
		delButton = new JButton("Entfernen");
		delButton.addActionListener(this);
		
		//--Menupanel: Anordnung
		panMenu.add(addButton);
		panMenu.add(loadButton);
		panMenu.add(delButton);
		
		
		//Einzelne Panels zum Kontainer hinzufgen
		c.add(panName, BorderLayout.NORTH); 
	    c.add(panMenu, BorderLayout.SOUTH); 
	    c.add(panList, BorderLayout.CENTER); 
	    
		//Containereigenschaften festlegen
		setTitle("V1_OOP_BorderLayout"); 
		setSize(600, 500); 
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	} 
	
	public void actionPerformed(ActionEvent event) 
	{   
		//Button Wert abholen
		String buttonValue = event.getActionCommand(); 
		
	    if (buttonValue.equals("Laden"))
	    {
	    	listData.reset();
	    }
	    else if(buttonValue.equals("Hinzufgen"))
	    {
	    	if (listData.contains(name.getText()))
	    	{
	    		JOptionPane.showMessageDialog(this,"Es gibt schon einen Eintrag mit den Namen "+name.getText()+"!","Eintrag schon vorhanden",JOptionPane.WARNING_MESSAGE);
	    	}
	    	else
	    	{
	    		listData.addString(name.getText());
	    	}
	    	name.setText(null);
	    }
	    else if (buttonValue.equals("Entfernen"))
	    {
	    	int opt = JOptionPane.showConfirmDialog(this,"Soll der eintrag " + nameList.getSelectedValue() + " wirklich gelscht werden?","Eintrag lschen!",JOptionPane.YES_NO_OPTION);
			if (opt==JOptionPane.YES_OPTION)
			{
				listData.remove(nameList.getSelectedIndex());
			}
	    }
	}
	
	public static void main(String[] args) 
	{ 
		new versuch1().setVisible(true); 
	} 
}